/*
 * SerialNetworkServicesView.java
 * 
 * Copyright (c) 2003-2004 Digi International
 * This program and the information contained in it is confidential and
 * proprietary to Digi International and may not be used, copied, or re-
 * produced without the prior written permission of Digi International.
 * 
 */

package com.digi.config.ui;

import com.digi.config.core.*;
import com.digi.config.util.*;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import java.net.*;




/** 
 * This class is a view panel that shows the network services
 * available for a serial port of the Digi Connect device.
 * 
 * This view can be embedded in other panels as desired.
 */


public class SerialNetworkServicesView extends ConfigViewImpl {
    /** A KvpNode that holds just the fields used in this view */
    KvpNode viewSettingTree;
    /** listens to the device for changes to settings */
    DeviceChangeListener settingChangeListener;
    /** Panel that holds the view content */
    GridContentPanel content;

    String serviceName[] = {
        "tcp",
        "ssl",
        "udp",
        "rtelnet",
    };


    String serviceSettingName[] = {
        "tcp_server",
        "securesocket",
        "udp_server",
        "telnet_server",
    };

    // Data Fields currently used in this view
    KvpField serverEnabledKvpField[] = new KvpField[serviceName.length];
    KvpField serverPortKvpField[] = new KvpField[serviceName.length];

    // UI Controls for each field
    JCheckBox    serverEnabled_UIC[] = new JCheckBox[serviceName.length];
    JTextField   serverPort_UIC[] = new JTextField[serviceName.length];


    /**
     * Constructor. Sets up the view controls
     */
    public SerialNetworkServicesView() throws Exception {
        // create the KvpNode and the change listener
        viewSettingTree = new KvpNode();
        settingChangeListener = new DeviceChangeListener() {
            public void deviceChanged(DeviceChangeEvent e) {
                //SystemLog.debug("SerialNetworkServicesView was notified that device kvpGroup changed");
                refreshViewData();
                refreshViewControls();
            }
        };
        // Create the panel that will hold the view controls
        content = new GridContentPanel(this.getName(),1);
        // create a listener that will detect when a user edits the field values
        ControlChangeAdapter fieldListener = new ControlChangeAdapter() {
            public void changePerformed(Object source, ActionEvent ae, FocusEvent fe) {
                //SystemLog.debug("SerialNetworkServicesView was notified that field "+source.toString()+" changed.");
                for (int i=0; i<serviceName.length; i++) {
                    if (source==serverEnabled_UIC[i]) {
                        serverEnabledKvpField[i].setStringValue(RciProtocol.toString(serverEnabled_UIC[i].isSelected()));
                    } else if (source==serverPort_UIC[i]) {
                        serverPortKvpField[i].setStringValue(serverPort_UIC[i].getText());
                    }
                }
            }
        };

        //
        // Create the fields and put them on the view
        //

        //content.addHeadingBar("SerialNetworkServicesHeading");
        content.addTextLine("SerialNetworkServicesDesc");
        content.addTextLine("SerialNetworkServicesDesc2");

        GridContentPanel serviceContent = new GridContentPanel(2);

        for (int i=0; i<serviceName.length; i++) {
            serverEnabled_UIC[i] = serviceContent.addJCheckBox(serviceName[i]+"ServerEnabled", fieldListener, 1, false);
            serverPort_UIC[i] = serviceContent.addJTextField(serviceName[i]+"ServerPort", serviceName[i]+"ServerPortDesc", 100, fieldListener, 2, true);
            serverPort_UIC[i].setDocument(createIntegerDocument());
        }

        content.addSubPanel(serviceContent);

        content.addVGlue();

    }

    /**
     * Returns a one word name identifying this view. 
     */
    public String getName() {
        return "SerialNetworkServicesView";
    }

    /** 
     * Return the Component that displays the primary content for this view
     */
    public Component getViewContent() {
        return content;
    }



    /**
     * Informs view what device to work with. View should flush any
     * cached device data and mark current view content as invalid
     * so that it is refreshed appropriatly.
     */
    public void setDevice(Device device) {
        super.setDevice(device);
        refreshViewData();
        refreshViewControls();
        device.addSettingChangeListener(settingChangeListener);
    }

    /**
     * Informs view to use the specified primary index in selecting the
     * data to display in the view. Not all views will support indexed
     * viewing and it is up to each view to define what the index is based 
     * upon. 
     * <p>
     * An example of an indexed view would be the SerialBasicView. This view
     * is indexed off the port # whose data is to be displayed in the view. An
     * external control in the SerialView lets the user select the port to view
     * and then that view instructs the SerialBasicView to use the selected 
     * port number as it's ViewIndex. Other views could use the index to base
     * their view off other integer keys such as Alarm#, Destination#,etc...
     * <p>
     * Views that do not support indexing can simply ignore this call.
     */
    public void setViewIndex(int primaryIndex) {
        super.setViewIndex(primaryIndex);
        // Rebind kvp fields for this port and then refresh controls
        bindFieldsForIndex(primaryIndex);
        refreshViewControls();
    }


    /** 
     * Refreshes the local copy of the kvpGroup displayed in the view. The updated kvpGroup come
     * from those currently cached in the Device
     */
    private void refreshViewData() {
        viewSettingTree.clear();
        int portCount=0;
        if (device!=null) {
            portCount = device.getInternalSettingTree().getChildCount("serial");
        }
        // refresh data for each port
        for (int port=1; port<=portCount; port++) {
            refreshViewDataForIndex(port);
        }
        bindFieldsForIndex(this.viewIndex);
    }


    /** 
     * Refreshes the local copy of the kvpGroup displayed in the view. The updated kvpGroup come
     * from those currently cached in the Device
     */
    private void refreshViewDataForIndex(int port) {
        for (int i=0; i<serviceName.length; i++) {
            viewSettingTree.mergeChild(device.getInternalSettingTree().getChild(serviceSettingName[i], port), true);
//            viewSettingTree.mergeFrom(device.getInternalSettingTree(), serviceSettingName[i], port, "state", 1); 
//            viewSettingTree.mergeFrom(device.getInternalSettingTree(), serviceSettingName[i], port, "port", 1); 
        }
    }


    /** 
     * Refreshes the local copy of the kvpGroup displayed in the view. The updated kvpGroup come
     * from those currently cached in the Device
     */
    private void bindFieldsForIndex(int port) {
        for (int i=0; i<serviceName.length; i++) {
            KvpNode service = viewSettingTree.getChild(serviceSettingName[i], port);
            serverEnabledKvpField[i] = (service==null) ? null : service.getChild("state"); 
            serverPortKvpField[i] = (service==null) ? null : service.getChild("port"); 
        }
    }


    /** 
     * Refreshes the state of the controls in the view to match the data in the views kvpGroup.
     */
    private void refreshViewControls() {
        for (int i=0; i<serviceName.length; i++) {
            serverPort_UIC[i].setEnabled(serverPortKvpField[i]!=null);
            if (serverPortKvpField[i]!=null) {
                serverPort_UIC[i].setText(serverPortKvpField[i].getStringValue());
            }
            serverEnabled_UIC[i].setEnabled(serverEnabledKvpField[i]!=null);
            if (serverEnabledKvpField[i]!=null) {
                serverEnabled_UIC[i].setSelected(RciProtocol.booleanValue(serverEnabledKvpField[i].getStringValue()));
            }
        }

        // If no service data is available, disable the entire panel
        if (serverEnabledKvpField[0]==null) {
            content.setContainerEnabled(false);
        }

    }


    /**
     * This method is called to instruct the view that it is about to be made
     * active. When a view is active it needs to make sure its content is correct.
     * An example of why a panel may be inactive is if it were on a tabbed pane 
     * and was not currently visible or if the user selected some other view.
     */
    public void activate() {
        SystemLog.debug("Activating "+getName());
    }

    /**
     * This method is called to instruct the view that it is about to be made
     * inactive. When a view is inactive, it does not need to worry
     * about maintaining its content in a correct state. An example of why a panel
     * may be inactive is if it were on a tabbed pane and was not currently visible
     * or if the user selected some other view.
     */
    public void deactivate() {
        SystemLog.debug("Deactivating "+getName());
    }

    /**
     * Indicates if any changes have been made by the user that have not yet been
     * saved to the device(ie committed).
     */
    public boolean isChanged() {
        return viewSettingTree.hasChanged();
    }

    /**
     * This method instructs the view to validate any of the changes the user has made
     * within the view. Any errors are to be added to the provided errorList. 
     * 
     * @param errorList is a collection of ViewValidationError objects
     */
    public void validateChanges(Collection errorList) {
        try {
            // Validate Servers
            for (int i=0; i<serviceName.length; i++) {
                if (serverEnabled_UIC[i].isSelected()) {
                    if (!ValidationHelper.isValidNetworkPort(serverPort_UIC[i].getText()) ||
                        (Integer.parseInt(serverPort_UIC[i].getText()) <= 0))
                        errorList.add(new ValidationError("Serial"+serviceName[i]+"ServerPortError"));
                }
            }
        } catch (Exception e) {
            System.out.println("Caught Exception in SerialNetworkServicesView::validationChanges()");
            e.printStackTrace();
        }
    }

    /**
     * This method instructs the view to place any changes the user has made within 
     * the view into the provided clusters. Once the changes have been saved to
     * to the device, a subsequent call to commitChanges() will be made.
     */
    public void getChanges(KvpNode settingCluster, KvpNode stateCluster) {
        // Merge the view changes into the provided cluster
        settingCluster.merge(viewSettingTree, false);
    }

    /**
     * Instructs the view to consider any user changes within the view as 
     * saved to the device (ie committed).
     */
    public void commitChanges() {
        // simply reset flags indicating user changes in the contols
        viewSettingTree.resetChanged();
    }

    /** 
     * Instructs the view to discard any changes the user has made within the
     * view and revert those fields to the original state. The view is also 
     * free to refresh all its fields to the present cached state of the device at 
     * this time.
     */
    public void cancelChanges() {
        refreshViewData();
        refreshViewControls();
    }


}

